(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: CETNOSTI.PAS                                                   *)
(*  Obsah: program pro pocitani cetnosti znaku v textu                     *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 22.12.2014                                            *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic, nebo nejaky soubor k otestovani                     *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program cetnosti_znaku_v_textu;

var ZadanyText:string; {tohle zada uzivatel z klavesnice: bud to bude jmeno
               souboru, nebo primo text ke zpracovani}
    ZeSouboru:boolean; {tady si poznamename, jestli pracujeme se souborem
               (true), nebo se zadanym textem (false)}
    Soubor:file of char; {tenhle typ je v tomhle pripade vyhodnejsi nez Text,
               protoze se nemusime zabyvat konci radku - cteme proste znak po
               znaku az do konce souboru (konce radku jsou znaky #13#10,
               ktere pak uvidime ve vypisu)}

    Znak:char; {znak nacteny ze souboru, pozdeji pomocny index pro cykly}
    Cetnosti:array[#0..#255] of longint; {cetnosti jednotlivych znaku
               (pro bezne pripady by stacil word, ale na hodne velkych
               souborech (teoreticky nad 64 KB, prakticky asi jeste
               nekolikanasobne vic) by mohl pretekat, tak radsi preventivne
               pouzijeme neco vetsiho)}
    NejcetnejsiZnaky:string; {seznam znaku s nejvetsi cetnosti}
    NejvetsiCetnost:longint;

    i:longint; {pomocny index pro cykly a jine pocitani}
    DesetinaVelikosti:longint; {1/10 velikosti souboru - pomocna hodnota pro vykreslovani ukazatele prubehu}

    SirkaCisla,SirkaBunky,PocetSloupcu:byte; {pomocne hodnoty pro zarovnavani vypisu}

BEGIN
{==Uvod==}
writeln;
writeln('Program pocitajici cetnosti znaku v textu');
writeln('=========================================');
writeln('Zadava se bud primo text ke kontrole, nebo jmeno souboru. Program si to');
writeln('rozlisi sam podle toho, jestli soubor s takovym jmenem najde.');
writeln;

{zadani vstupniho textu:}
write('Zadejte text (samotny Enter znamena konec programu): ');
readln(zadanytext);
if zadanytext='' then begin
                      writeln('Zadavani zruseno, koncime.');
                      halt; {okamzite ukonceni programu}
                      end;
writeln;

{pokus o otevreni souboru, jestli existuje:}
{$I-} {vypnuti automaticke kontroly operaci se soubory, aby nam program pri neexistujicim souboru nespadl}
assign(soubor,zadanytext); {propojeni souborove promenne se skutecnym souborem}
reset(soubor); {pokus o otevreni souboru pro cteni; jak to dopadlo se dozvime pomoci funkce Ioresult}
zesouboru:=ioresult=0; {Pokud je ioresult=0, otevreni souboru bylo uspesne.
          Nenulova hodnota znamena chybu, tedy nejspis neexistujici soubor.}
{$I+} {zapnuti automaticke kontroly, abychom nemuseli po kazdem nactenem znaku rucne testovat ioresult}

{==Pocitani==}
fillchar(cetnosti,sizeof(cetnosti),0); {tohle je asi nejpohodlnejsi zpusob
                                  vyplneni jakekoli promenne nulami (funkce
                                  SizeOf vraci velikost promenne v bytech)}
if zesouboru
  then begin
       {cteni souboru znak po znaku je dost pomale, proto potrebujeme nejaky
       ukazatel prubehu, aby si uzivatel nemyslel, ze se program zasekl:}
       desetinavelikosti:=filesize(soubor) div 10;
       write('Pracuji: [..........]');
       for i:=1 to 11 do write(#8); {jedenact backspacu posune kurzor doleva na prvni tecku}
       i:=0; {ted bude pocitat nactene znaky}
       while not eof(soubor) do {dokud je co cist (EOF znamena End Of File - konec souboru)}
         begin
         read(soubor,znak); {precti ze souboru jeden znak}
         inc(cetnosti[znak]); {cetnost toho znaku zvys o 1 (ekvivalent zapisu neco:=neco+1, ale usetri se trochu psani)}
         inc(i);
         if i>=desetinavelikosti then begin {po kazde desetine souboru nakreslime do stavoveho radku jednu hvezdicku}
                                      write('*');
                                      i:=0;
                                      end;
         end;
       close(soubor); {nakonec soubor zavreme}
       writeln; {ukonceni radku s ukazatelem prubehu}
       writeln; {vynechani jednoho radku pod nim}
       writeln('Cetnosti znaku v souboru ',zadanytext,':');
       end
  else begin {zpracovani primo zadaneho textu je podstatne jednodussi :-)}
       for i:=1 to length(zadanytext) do {projdi text od zacatku do konce...}
         inc(cetnosti[zadanytext[i]]); {...a u kazdeho znaku zvys prislusnou cetnost o 1}
       writeln('Cetnosti znaku v textu "',zadanytext,'":');
       end;

{==Vypis vysledku==}
{nejdriv zjistime, jak velka cisla jsme napocitali a kolik se nam jich na
obrazovku vejde vedle sebe:}
nejvetsicetnost:=0;
nejcetnejsiznaky:='';
for znak:=#0 to #255 do {pro vsechny mozne znaky}
  if cetnosti[znak]<>0 {jestli tam tenhle znak vubec byl}
    then if cetnosti[znak]=nejvetsicetnost {dalsi znak se stejnou cetnosti, jako je dosud nalezene maximum?}
           then nejcetnejsiznaky:=nejcetnejsiznaky+znak {pridej ho do seznamu}
           else if cetnosti[znak]>nejvetsicetnost {cetnejsi nez dosud nalezene maximum?}
                  then begin
                       nejcetnejsiznaky:=znak; {minulou verzi seznamu zahod a uloz do nej tenhle znak}
                       nejvetsicetnost:=cetnosti[znak]; {a uloz nove maximum}
                       end;
{promennou Zadanytext uz nebudeme potrebovat, tak ji muzeme zneuzit pro
pomocne vypocty:}
str(nejvetsicetnost,zadanytext); {nejvetsi cislo si prevedeme na text...}
sirkacisla:=length(zadanytext); {...a tim zjistime, kolik ma cifer}
sirkabunky:=sirkacisla+8; {k tomu pridame misto na zobrazeni znaku, oddelovacich mezer a podobne}
pocetsloupcu:=79 div sirkabunky; {radek na obrazovce je dlouhy 80 znaku, ale
 posledni pozici radsi nechame volnou - kdyz se na ni neco napise, kurzor
 automaticky skoci na dalsi radek a tim by se nam rozhodilo radkovani}
i:=0; {ted poslouzi k pocitani bunek na radku}
for znak:=#0 to #255 do
  if cetnosti[znak]<>0 then begin
                            if znak<#10 then write(' '); {jednociferne kody je potreba vycpat mezerou zleva}
                            {netisknutelne znaky ze zacatku ASCII tabulky piseme jako #+cislo, ostatni primo:}
                            if znak<#32 then write('#',ord(znak))
                                        else write('''',znak,'''');
                            write(':',cetnosti[znak]:sirkacisla,'    ');
                            inc(i);
                            if i>=pocetsloupcu then begin {jsme na konci radku}
                                                    writeln;
                                                    i:=0;
                                                    end;
                            end;
if i<>0 then writeln; {zakonceni posledniho radku tabulky (jestli i=0, tak uz mame zakonceno)}

writeln;
if length(nejcetnejsiznaky)=1 {mame jenom jeden nejcetnejsi znak?}
  then writeln('Nejcetnejsi znak je ''',nejcetnejsiznaky,''', je tam celkem ',nejvetsicetnost,'krat.')
  else begin {jestli je na prvnim miste vic znaku, vypiseme vsechny}
       write('Nejcetnejsi znaky jsou ');
       for i:=1 to length(nejcetnejsiznaky)-2 do {nejdriv je oddelujeme carkami                                      }
         write('''',nejcetnejsiznaky[i],''', '); {(kdyby byly jenom dva znaky, tenhle cyklus se neprovede ani jednou)}
       write('''',nejcetnejsiznaky[length(nejcetnejsiznaky)-1],''' a '); {posledni dva oddelime spojkou "a"}
       write('''',nejcetnejsiznaky[length(nejcetnejsiznaky)],'''');
       writeln(' - kazdy z nich je tam ',nejvetsicetnost,'krat.');
       end;

{zaverecna pauza, aby si uzivatel stihl precist vysledky:}
writeln;
writeln('Pro ukonceni programu zmacknete Enter.');
readln;
END.